enum {
	Nconn = 8,			/* max simultanious HTTP connections */
};

typedef vlong Seq;
typedef struct Sess Sess;
typedef struct Chunk Chunk;
typedef struct Sublist Sublist;
typedef struct Playlist Playlist;

struct Sess {
	char *webfs;		/* mountpoint of webfs */
	char *agent;		/* agent string */
	int net[Nconn];		/* network file descriptors */
	int conid[Nconn];	/* network connection IDs */
	int dec;			/* file descriptor - pipe to codec */
	char decpath[128];	/* path of codec */
	Seq seqno;			/* sequence number (chunked streams only) */
	char *title;		/* last title printed */
	char *artist;		/* last artist printed */
};

struct Playlist {
	Chunk *chunks;		/* chunk parsed */
	Seq seqbase;		/* base sequence number (chunked streams only) */
	int chunked;		/* is chunked stream */
	int live;			/* playlist may change under our feet */
	int isaudio;		/* contains audio urls */
	void *aux;			/* private to parser, used by m3u8.c */
};

struct Chunk {
	Chunk *next;		/* next in file */
	char *url;			/* file/stream/child playlist */
	char *title;		/* song title */
	char *artist;		/* artist's name */
	double secs;		/* duration */
	int bw;				/* bandwidth required (chunked streams only)*/
	vlong start;		/* start of byterange (chunked streams only) */
	vlong end;			/* end of byterange (chunked streams only) */
	void *aux;			/* private state for the parser */
};

extern char *Debug;
extern int Narrowband;
