#include <u.h>
#include <libc.h>
#include <bio.h>
#include <xml.h>
#include "dat.h"
#include "fns.h"

static State Title = { "title",	"" };
static State Duration = { "duration",	"" };
static State Station = { "station",	"" };
static State Url = { "url",	"" };
static State Author = { "author",	"" };
static State Date = { "date",	"" };

void
poll(Sess *s, char *url)
{
	int fd;
	Xml *xp;
	long msec;
	Elem *ep, *item;

	msec = 60*1000;
	for(;;){
		if((fd = httpredial(s, url, nil, 0)) < 0){
			if(! notmodified())
				fprint(2, "%s: %s httpredial failed, %r\n", argv0, url);
			goto again;
		}

		if((xp = xml_parse(fd, 1024*10, Fcrushwhite|Fstripnamespace)) == nil){
			fprint(2, "parse of last.fm xml_ML failed\n");
			close(fd);
			goto again;
		}
		close(fd);

		if((ep = xml_find(xp, xp->root, "Playlist/Refresh")) != nil){
			if(ep->pcdata){
				msec = atol(ep->pcdata);
				if(msec < 10000 || msec > 60000*2)
					msec = 60000;
			}
		}

		if((ep = xml_find(xp, xp->root, "rss/channel/title")) != nil && ep->pcdata)
			upd(&Title, ep->pcdata);


		if((item = xml_find(xp, xp->root, "rss/channel/item")) != nil)
			for(; item; item = item->next){
fprint(2, "%s\n", item->child->name);
				if(item->child == nil)
					continue;
				if((ep = xml_find(xp, item->child, "pubDate")) != nil && ep->pcdata)
					upd(&Date, ep->pcdata);
				if((ep = xml_find(xp, item->child, "link")) != nil && ep->pcdata)
					upd(&Url, ep->pcdata);
			}

		xml_free(xp);
		Bflush(&Out);
again:
		sleep(msec/2 + lnrand(msec));
	}
}

